# coding: utf-8

"""
Notehub API

The OpenAPI definition for the Notehub.io API.

The version of the OpenAPI document: 1.2.0
Contact: engineering@blues.io
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import (
    BaseModel,
    ConfigDict,
    Field,
    StrictBool,
    StrictFloat,
    StrictInt,
    StrictStr,
)
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self


class Event(BaseModel):
    """
    Event
    """  # noqa: E501

    event: Optional[StrictStr] = Field(
        default=None, description="Event UID (globally unique)"
    )
    session: Optional[StrictStr] = Field(
        default=None, description="Session UID (globally unique)"
    )
    tls: Optional[StrictBool] = Field(
        default=None,
        description="Whether TLS was used on the connection between the device and notehub. Only available on _session.qo events.",
    )
    transport: Optional[StrictStr] = Field(
        default=None,
        description='The transport used for this event, e.g., "cellular", "wifi", ", etc.',
    )
    best_id: Optional[StrictStr] = Field(
        default=None,
        description="The device serial number, or the DeviceUID if the serial number is not set",
    )
    device: Optional[StrictStr] = Field(
        default=None, description="Device UID (globally unique)"
    )
    sn: Optional[StrictStr] = Field(
        default=None, description="The device serial number"
    )
    product: Optional[StrictStr] = Field(
        default=None, description="Product UID (globally unique)"
    )
    app: Optional[StrictStr] = Field(
        default=None, description="App UID (globally unique)"
    )
    received: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="The unix timestamp when the event was received"
    )
    req: Optional[StrictStr] = Field(default=None, description="The notecard request")
    when: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="When the event was captured on the device"
    )
    file: Optional[StrictStr] = Field(
        default=None, description="The notefile associated with this event"
    )
    note: Optional[StrictStr] = Field(
        default=None, description="The note ID in the notefile"
    )
    updates: Optional[Union[StrictFloat, StrictInt]] = None
    body: Optional[Dict[str, Any]] = Field(
        default=None, description="A JSON object containing event details"
    )
    payload: Optional[StrictStr] = Field(
        default=None, description="A base64-encoded binary payload"
    )
    best_location_type: Optional[StrictStr] = Field(
        default=None, description='One of "gps", "triangulated", or "tower"'
    )
    best_location_when: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="Unix timestamp"
    )
    best_lat: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="Latitude"
    )
    best_lon: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="Longitude"
    )
    best_location: Optional[StrictStr] = Field(default=None, description="Location")
    best_country: Optional[StrictStr] = Field(default=None, description="Country")
    best_timezone: Optional[StrictStr] = Field(default=None, description="Timezone")
    where_olc: Optional[StrictStr] = Field(
        default=None, description="Open Location Code"
    )
    where_when: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="Unix timestamp"
    )
    where_lat: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="Latitude"
    )
    where_lon: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="Longitude"
    )
    where_location: Optional[StrictStr] = Field(default=None, description="Location")
    where_country: Optional[StrictStr] = Field(default=None, description="Country")
    where_timezone: Optional[StrictStr] = Field(default=None, description="Timezone")
    tower_when: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="Unix timestamp"
    )
    tower_lat: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="Latitude"
    )
    tower_lon: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="Longitude"
    )
    tower_country: Optional[StrictStr] = Field(default=None, description="Country")
    tower_location: Optional[StrictStr] = Field(default=None, description="Location")
    tower_timezone: Optional[StrictStr] = Field(default=None, description="Timezone")
    tower_id: Optional[StrictStr] = Field(default=None, description="Tower ID")
    tri_when: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="Unix timestamp"
    )
    tri_lat: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="Latitude"
    )
    tri_lon: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="Longitude"
    )
    tri_location: Optional[StrictStr] = Field(default=None, description="Location")
    tri_country: Optional[StrictStr] = Field(default=None, description="Country")
    tri_timezone: Optional[StrictStr] = Field(default=None, description="Timezone")
    tri_points: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="Triangulation points"
    )
    moved: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None,
        description="The number of times the device was sensed to have moved between the last session and this session. Only available on _session.qo events.",
    )
    orientation: Optional[StrictStr] = Field(
        default=None,
        description="The orientation of the device. Only available on _session.qo events.",
    )
    rssi: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None,
        description="Received Signal Strength Indicator (RSSI) is an estimated measurement of how well a device can receive signals. Only available on _session.qo events.",
    )
    sinr: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="SINR. Only available on _session.qo events."
    )
    rsrp: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="RSRP. Only available on _session.qo events."
    )
    rsrq: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="RSRQ. Only available on _session.qo events."
    )
    rat: Optional[StrictStr] = Field(
        default=None, description="Rat. Only available on _session.qo events."
    )
    bars: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="Bars. Only available on _session.qo events."
    )
    voltage: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None,
        description="Device voltage. Only available on _session.qo events.",
    )
    temp: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None,
        description="Device temperature. Only available on _session.qo events.",
    )
    environment: Optional[Dict[str, Any]] = Field(
        default=None,
        description='Routed environment variables beginning with "$". Only available on _session.qo events.',
    )
    sku: Optional[StrictStr] = Field(
        default=None, description="SKU. Only available on _session.qo events."
    )
    ordering_code: Optional[StrictStr] = Field(
        default=None, description="Ordering code. Only available on _session.qo events."
    )
    ssid: Optional[StrictStr] = Field(
        default=None, description="SSID. Only available on _session.qo events."
    )
    bssid: Optional[StrictStr] = Field(
        default=None, description="BSSID. Only available on _session.qo events."
    )
    __properties: ClassVar[List[str]] = [
        "event",
        "session",
        "tls",
        "transport",
        "best_id",
        "device",
        "sn",
        "product",
        "app",
        "received",
        "req",
        "when",
        "file",
        "note",
        "updates",
        "body",
        "payload",
        "best_location_type",
        "best_location_when",
        "best_lat",
        "best_lon",
        "best_location",
        "best_country",
        "best_timezone",
        "where_olc",
        "where_when",
        "where_lat",
        "where_lon",
        "where_location",
        "where_country",
        "where_timezone",
        "tower_when",
        "tower_lat",
        "tower_lon",
        "tower_country",
        "tower_location",
        "tower_timezone",
        "tower_id",
        "tri_when",
        "tri_lat",
        "tri_lon",
        "tri_location",
        "tri_country",
        "tri_timezone",
        "tri_points",
        "moved",
        "orientation",
        "rssi",
        "sinr",
        "rsrp",
        "rsrq",
        "rat",
        "bars",
        "voltage",
        "temp",
        "environment",
        "sku",
        "ordering_code",
        "ssid",
        "bssid",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Event from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Event from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "event": obj.get("event"),
                "session": obj.get("session"),
                "tls": obj.get("tls"),
                "transport": obj.get("transport"),
                "best_id": obj.get("best_id"),
                "device": obj.get("device"),
                "sn": obj.get("sn"),
                "product": obj.get("product"),
                "app": obj.get("app"),
                "received": obj.get("received"),
                "req": obj.get("req"),
                "when": obj.get("when"),
                "file": obj.get("file"),
                "note": obj.get("note"),
                "updates": obj.get("updates"),
                "body": obj.get("body"),
                "payload": obj.get("payload"),
                "best_location_type": obj.get("best_location_type"),
                "best_location_when": obj.get("best_location_when"),
                "best_lat": obj.get("best_lat"),
                "best_lon": obj.get("best_lon"),
                "best_location": obj.get("best_location"),
                "best_country": obj.get("best_country"),
                "best_timezone": obj.get("best_timezone"),
                "where_olc": obj.get("where_olc"),
                "where_when": obj.get("where_when"),
                "where_lat": obj.get("where_lat"),
                "where_lon": obj.get("where_lon"),
                "where_location": obj.get("where_location"),
                "where_country": obj.get("where_country"),
                "where_timezone": obj.get("where_timezone"),
                "tower_when": obj.get("tower_when"),
                "tower_lat": obj.get("tower_lat"),
                "tower_lon": obj.get("tower_lon"),
                "tower_country": obj.get("tower_country"),
                "tower_location": obj.get("tower_location"),
                "tower_timezone": obj.get("tower_timezone"),
                "tower_id": obj.get("tower_id"),
                "tri_when": obj.get("tri_when"),
                "tri_lat": obj.get("tri_lat"),
                "tri_lon": obj.get("tri_lon"),
                "tri_location": obj.get("tri_location"),
                "tri_country": obj.get("tri_country"),
                "tri_timezone": obj.get("tri_timezone"),
                "tri_points": obj.get("tri_points"),
                "moved": obj.get("moved"),
                "orientation": obj.get("orientation"),
                "rssi": obj.get("rssi"),
                "sinr": obj.get("sinr"),
                "rsrp": obj.get("rsrp"),
                "rsrq": obj.get("rsrq"),
                "rat": obj.get("rat"),
                "bars": obj.get("bars"),
                "voltage": obj.get("voltage"),
                "temp": obj.get("temp"),
                "environment": obj.get("environment"),
                "sku": obj.get("sku"),
                "ordering_code": obj.get("ordering_code"),
                "ssid": obj.get("ssid"),
                "bssid": obj.get("bssid"),
            }
        )
        return _obj
